<template>
  <div>
    <div v-for="(item, i) in combinedList" :key="i">
      <editorial-content-info-box v-if="item.is === 'editorial-content'" :item="item"/>
      <pv-data-info-box v-if="item.is === 'dataset'"
                        :to="`/datasets/${item.id}?locale=${locale}`"
                        :src="getImg(getCatalogImage(item.catalog))" :dataset="{
                   title:
                     getTranslationFor(
                       item.title,
                       locale,
                       item.languages
                     ) || item.id,
                   description: getTranslationFor(
                     item.description,
                     locale,
                     item.languages
                   ),
                   catalog: getTranslationFor(
                     item.catalog.title,
                     locale,
                     []
                   ),
                   createdDate: item.releaseDate,
                   updatedDate: item.modificationDate,
                   formats: removeDuplicatesOf(item.distributionFormats).filter(
                     (format) => format.id || format.label
                   ),
                 }" :description-max-length="1000" :data-cy="`dataset@${item.id}`" class="mt-3" />
      <pv-data-info-box
        v-if="item.is === 'catalog'"
        catalog-mode
        :to="datasetsRoute(item.id)"
        :src="getImg(getCatalogImage(item))"
        :dataset="{
                title: getTranslationFor(
                  item.title,
                  locale,
                  getCatalogLanguages(item)
                ),
                description: getTranslationFor(
                  item.description,
                  locale,
                  getCatalogLanguages(item)
                ),
                catalog: getTranslationFor(
                  item.title,
                  locale,
                  getCatalogLanguages(item)
                ),
                createdDate: null,
                updatedDate: null,
                formats: [],
              }"
        :description-max-length="1000"
        :data-cy="`catalog@${item.id}`"
        class="mt-3"
      />
    </div>
  </div>
</template>

<script>
import {mapGetters} from "vuex";
import {helpers} from "@piveau/piveau-hub-ui-modules";
import {groupBy, has, toPairs, uniqBy} from "lodash-es";
import EditorialContentInfoBox from "@/components/search/combined/EditorialContentInfoBox";

const { getImg, getTranslationFor, truncate } = helpers;

export default {
  name: "CombinedList",
  components: {EditorialContentInfoBox},
  data() {
    return {
      baseUrl: this.$env.api.baseUrl
    }
  },
  computed: {
    ...mapGetters("datasets", ["getDatasets"]),
    ...mapGetters("catalogs", ["getCatalogs"]),
    ...mapGetters("search", ["getEditorialContentItems"]),
    locale() {
      return this.$route.query.locale;
    },
    combinedList() {
      const items = [];//this.getDatasets;
      let datasetIndex = 0;
      let catalogIndex = 0;
      let resourceIndex = 0;
      const datasetCount = this.getDatasets.length;
      const catalogCount = this.getCatalogs.length;
      const resourceCount = this.getEditorialContentItems.length;
      const iterations = Math.max(datasetCount, Math.max(catalogCount, resourceCount));
      for (let i = 0; i < iterations; ++i) {
        if (datasetIndex < datasetCount) {
          items.push({...this.getDatasets[datasetIndex++], is: 'dataset'});
        }
        if (catalogIndex < catalogCount) {
          items.push({...this.getCatalogs[catalogIndex++], is: 'catalog'});
        }
        if (resourceIndex < resourceCount) {
          items.push({...this.getEditorialContentItems[resourceIndex++], is: 'editorial-content'});
        }
      }
      return items;
    }
  },
  methods: {
    getImg,
    getTranslationFor,
    truncate,
    getCatalogImage(catalog) {
      return this.$env.content.catalogs.useCatalogCountries
        ? `${this.$env.content.catalogs.defaultCatalogImagePath}/${has(catalog, "country.id")
          ? catalog.country.id
          : this.$env.content.catalogs.defaultCatalogCountryID
        }`
        : `${this.$env.content.catalogs.defaultCatalogImagePath}/${has(catalog, "id")
          ? catalog.id
          : this.$env.content.catalogs.defaultCatalogID
        }`;
    },
    /**
     * @description Removes the duplicates of the given array
     * @param array {Array} - The array to remove duplicates from
     * @returns {Array}
     */
    removeDuplicatesOf(array) {
      const correctedFormatArray = array.map((format) => ({
        ...format,
        id: this.getBadgeFormat(format.id),
        label: this.getBadgeFormat(format.label),
      }));
      // sorts after # of occurences (highest occurence first)
      // possibility #1
      const sortedArray = toPairs(groupBy(correctedFormatArray, "id")).sort(
        (a, b) => b[1].length - a[1].length
      );
      const onlyFormatObjectsArray = sortedArray.map((arr) => arr[1][0]);
      // lodash uniqBy funtion removes duplicate id´s from array of objects
      const uniqById = uniqBy(onlyFormatObjectsArray, "id");
      return uniqBy(uniqById, "label");
    },
    /**
     * @description Cuts badge format string (max 8 chars)
     * @param label {String} - badge label or id (e.g. csv)
     */
    getBadgeFormat(label) {
      return this.truncate(label, 8, true);
    },
    datasetsRoute(catalogId) {
      return {
        path: `/catalogues/${catalogId}`,
        query: {
          locale: this.$route.query.locale
        }
      }
    },
    getCatalogLanguages(catalog) {
      return has(catalog, "country.id")
        ? [catalog.country.id].concat(catalog.languages)
        : catalog.languages;
    },
  }
}
</script>
